#ifndef CDO_CDI_WRAPPER_H
#define CDO_CDI_WRAPPER_H

#include <string>
#include <utility>

#include "mpim_grid/grid_healpix.h"

// convert a CDI filetype to string
const char *cdi_filetype_to_str(int filetype);

// convert a CDI datatype to string
const char *cdi_datatype_to_str(int datatype);
int cdo_str_to_datatype(const char *datatypestr);

// create Taxis(cdi) with added check/setting of taxisType
int cdo_taxis_create(int taxisType);
void cdo_taxis_copy_timestep(int taxisIDdes, int taxisIDsrc);

// cdi
void grid_gen_xvals(int xsize, double xfirst, double xlast, double xinc, double *xvals);
void grid_gen_yvals(int gridtype, int ysize, double yfirst, double ylast, double yinc, double *yvals);

void cdo_def_table_id(int tableID);

int cdo_inq_att_int(int cdiID, int varID, const std::string &attname);
std::string cdo_inq_att_string(int cdiID, int varID, const std::string &attname);
std::string cdo_inq_key_string(int cdiID, int varID, int key);
std::string cdo_inq_var_name(int vlistID, int varID);
std::string cdo_inq_var_longname(int vlistID, int varID);
std::string cdo_inq_var_units(int vlistID, int varID);

std::pair<int, HpOrder> cdo_get_healpix_params(int gridID);

#endif
